///////////////////////////////////////////////////////////
// ReflexResizer
// By Philippe Leefsma
// December 2016
//
///////////////////////////////////////////////////////////
import ReactDOM from 'react-dom'
import React from 'react'

export default class ReflexResizer
  extends React.Component {

  /////////////////////////////////////////////////////////
  //
  //
  /////////////////////////////////////////////////////////
  static propTypes = {
    className: React.PropTypes.string
  }

  /////////////////////////////////////////////////////////
  //
  //
  /////////////////////////////////////////////////////////
  static defaultProps = {
    className: ''
  }

  /////////////////////////////////////////////////////////
  //
  //
  /////////////////////////////////////////////////////////
  constructor () {

    super()

    this.state = {
      style: {}
    }
  }

  /////////////////////////////////////////////////////////
  //
  //
  /////////////////////////////////////////////////////////
  fillParent () {

    const domElement = ReactDOM.findDOMNode(this)

    const parent = domElement.parentNode

    this.setState({
      style: {
        height: parent.offsetHeight,
        width: parent.offsetWidth
      }
    })
  }

  /////////////////////////////////////////////////////////
  //
  //
  /////////////////////////////////////////////////////////
  componentWillReceiveProps () {

    this.fillParent()
  }

  /////////////////////////////////////////////////////////
  //
  //
  /////////////////////////////////////////////////////////
  render () {

    const classNames = [
      'reflex-resizer',
      ...this.props.className.split(' ')
    ]

    const style = Object.assign({},
      this.state.style,
      this.props.style)

    return (
      <div className={classNames.join(' ')} style={style}>
        { this.props.children }
      </div>
    )
  }
}
